#!/usr/bin/python
#encoding: utf8
"""
This file contains the functions handling files
"""
import codecs
import os
import project_config
import filecmp

def mkdir(*args):
	"""create directories"""
	for arg in args:
		try:
			os.mkdir(os.path.join('src', arg))
		except OSError:
			pass

def compare_files(file_list):
	for filename in file_list:
		try:
			if not filecmp.cmp(filename, '%s.new'%(filename,)):
				os.remove(filename)
				os.rename('%s.new'%(filename,), filename)
			else:
				os.remove('%s.new'%(filename,))
		except OSError:
			os.rename('%s.new'%(filename,), filename)

tracking_file = lambda: codecs.open(os.path.join('src', 'table', project_config.tracking_table_name),'r','utf8')
lang_input_file = lambda lang: codecs.open(os.path.join("lang",'%s.lng.in'%(lang,)),'r','utf8')
language_file = lambda lang: codecs.open(os.path.join("lang",'%s.lng'%(lang,)),'w','utf8')
callbacks_file = lambda: codecs.open(os.path.join("src",'callbacks.gnml'),'w','utf8')
table_file = lambda: codecs.open(os.path.join('docs', project_config.formatted_tracking_table_name),'w','utf8')
engine_sort_file = lambda: codecs.open(os.path.join("src",'engine_sort.gnml'),'w','utf8')
engines_file = lambda: codecs.open('combine_engines.sh','w','utf8')
defines_file = lambda: codecs.open(os.path.join("src",'defines.gnml'),'w','utf8')
availability_file = lambda: codecs.open(os.path.join("src",'availability.gnml'),'w','utf8')
gfx_deps_file = lambda: codecs.open(project_config.project_short_name + '.gfx.dep','w','utf8')
src_deps_file = lambda: codecs.open(project_config.project_short_name + '.src.dep','w','utf8')
template_file = lambda length: codecs.open(os.path.join("src", 'gfx_front_vehicle_%d.gnml'%(length,)),'w','utf8')
dummy_code_file = lambda: codecs.open(os.path.join("src", 'dummy_code.gnml'),'w','utf8')
def vehicle_file(comp, ident, files_table):
	# if file was opened before, open for appending instead of creating an empty file
	if files_table.get((comp, ident), None) is not None:
		file = codecs.open(os.path.join("src","%s"%(comp,),'%s.gnml.new'%(ident,)),'a','utf8')
	else:
		file = codecs.open(os.path.join("src","%s"%(comp,),'%s.gnml.new'%(ident,)),'w','utf8')
		files_table[(comp, ident)] = os.path.join('src', "%s"%(comp,), '%s.gnml'%(ident,))
	return file
