#!/usr/bin/python
#encoding: utf8
"""
This file contains the helper function for starting the graphics parser
"""

# set up the parser for graphics evaluation
import ply.lex
import ply.yacc

import tokens
import rules
from error import error

lexer  = ply.lex.lex(module=tokens)
parser = ply.yacc.yacc(module=rules, write_tables=0)

def parse(string, debug=0):
	try:
		return parser.parse(string, lexer=lexer, debug=debug)
	except Exception, e:
		error("parsing failed: %s\n%s\n"%(string, e))
